﻿<%@ Control Language="C#" AutoEventWireup="true" CodeBehind="DayStats.ascx.cs" Inherits="MQAWeb.Forms.FTE.Agents.Dashboards.DayStats" %>
<%@ Register assembly="Ext.Net" namespace="Ext.Net" tagprefix="ext" %>
<script type="text/javascript">
    var topChart;
    function onTopInitialize(categories, countdata, filedata, bytedata) 
    {
        topChart = new Highcharts.Chart(
        {
            chart: { renderTo: 'chart_top_container', type: 'bar', events:
                {
                    load: function () { setTimeout(function () { onTopRedraw(); }, 5000); }
                }
            },
            credits: { enabled: false },
            plotOptions: { bar: { dataLabels: { enabled: true, formatter: function () { return Highcharts.numberFormat(this.y, 0); } }} },
            title: { text: '' },
            tooltip:
            {
                formatter: function () {
                    var value = Highcharts.numberFormat(this.y, 0);
                    if (this.series.name == 'Size (MB)')
                        value = Highcharts.numberFormat(this.y, 2);
                    return '<b>' + this.series.name + '</b><br/>' + this.x + '<br/>' + value;
                }
            },
            yAxis: { labels: { enabled: false }, title: { text: ''} },
            xAxis: {categories: categories},
            series: [{ data: countdata, name: 'Transfers' }, { data: filedata, name: 'Files' }, { data: bytedata, name: 'Size (MB)'}]
        });
    }

    function onTopAddPoints(categories, countdata, filedata, bytedata) 
    {
        try 
        {
            // routine to add points to the chart
            if (topChart.xAxis == null || topChart.xAxis == 'undefined') 
            {
                return;            
            }
            else 
            {
                if (!topChart.xAxis.length) 
                {
                    topChart.addAxis({ categories: categories }, true, false);
                }
                else {
                    topChart.xAxis[0].setCategories(categories, false);
                }
            }
            // add the series
            topChart.series[0].setData(countdata, false);
            topChart.series[1].setData(filedata, false);
            topChart.series[2].setData(bytedata, false);
            onTopRedraw();
        }
        catch (err) 
        {
            alert('Top '+ err);
        }
    }
    function onTopRedraw() {

    
        // routine to refresh the chart
        if (!topChart || !topChart.renderTo)
            return;
        var panel = Ext.get(topChart.renderTo);
        if (panel) 
        {
            var size = panel.getSize();
            topChart.setSize(size.width, size.height);
    topChart.redraw();
        }
    }
</script>

<ext:FormPanel ID="basePanel" runat="server">
<Items>
<ext:ComboBox ID="cmbTime" FieldLabel="Time Period" Editable="False" runat="server" SelectedIndex="0" AnchorHorizontal="100%">
    <Items>
        <ext:ListItem Text="All Day" Value="0"  />
        <ext:ListItem Text="Last 15 Minutes" Value="15" />
        <ext:ListItem Text="Last 30 Minutes" Value="30" />
        <ext:ListItem Text="Last 45 Minutes" Value="45" />
        <ext:ListItem Text="Last Hour" Value="60" />
    </Items>
  </ext:ComboBox>
</Items>
</ext:FormPanel>
<div id='chart_top_container'></div>
 <asp:UpdatePanel ID="pnlUpdate" runat="server" UpdateMode="Conditional">
</asp:UpdatePanel>  