﻿<%@ Control Language="C#" AutoEventWireup="true" CodeBehind="DayWorkload.ascx.cs" Inherits="MQAWeb.Forms.FTE.Agents.Dashboards.DayWorkload" %>
<%@ Register assembly="Ext.Net" namespace="Ext.Net" tagprefix="ext" %>
<script type="text/javascript">
    var chartWorkload;
    function onWorkloadChartInvokeRefresh(widgetId)
     {
        var widget = Ext.getCmp(widgetId);
        doServerCommand(widgetId + 'Controller', widgetId + 'Command', new CommandData('refresh', null), widget.el.dom, null);
    }

    function onWorkloadAddPoints(year, month, day, hour, min, sec, count, files, bytes) 
    {
        // routine to add points to the chart
        try {
            var date = Date.UTC(year, month, day, hour, min);

            // check if the chart has a series
            if (!chartWorkload.series[0].points.length) 
            {
                // get the data
                var countdata = [];
                countdata.push([date, count]);
                var filedata = [];
                filedata.push([date, files]);
                var bytedata = []
                bytedata.push([date, bytes]);
                chartWorkload.series[0].setData(countdata);
                chartWorkload.series[1].setData(filedata);
                chartWorkload.series[2].setData(bytedata);
            }
            else {

                var shift = chartWorkload.series[0].data.length > 10;
                chartWorkload.series[0].addPoint([date, count], false, shift);
                chartWorkload.series[1].addPoint([date, files], false, shift);
                chartWorkload.series[2].addPoint([date, bytes], false, shift);
            }
            onChartWorkloadRedraw();
        }
        catch (err) 
        {
            alert('work-point:' + err);
        }
    }

    function onWorkloadChartInitialize(widgetId, year, month, day, hour, min, sec, count, files, bytes) 
    {
        try 
        {
            // get the data
            var date = Date.UTC(year, month, day, hour, min);
            var countdata = [];
            countdata.push([date, count]);
            var filedata = [];
            filedata.push([date, files]);
            var bytedata = []
            bytedata.push([date, bytes]);

            chartWorkload = new Highcharts.Chart({
                chart: { renderTo: 'chart_workload_container', type: 'spline', marginRight: 10,
                    animation: { duration: 940, easing: 'linear' },
                    events:
            {
                load: function () {
                    setInterval(function () {
                        onWorkloadChartInvokeRefresh(widgetId);
                    }, 60000);
                }
            }
                },
                xAxis:
            {
                type: 'datetime',
                tickInterval: 60 * 1000
            },
                yAxis:
            {
                title:
                {
                    text: 'Value'
                }
            },
                tooltip:
            {
                formatter: function () {
                    value = Highcharts.numberFormat(this.y, 0);
                    if (this.series.name == 'Size (MB)')
                        value = Highcharts.numberFormat(this.y, 2);
                    return '<b>' + this.series.name + '</b><br/>' + Highcharts.dateFormat('%Y-%m-%d %H:%M:%S', this.x) + '<br/>' + value;
                }
            },
                legend:
           {
               enabled: true
           },
                series: [{ name: 'Transfers', data: countdata, pointInterval: 60 * 1000 }, { name: 'Files', data: filedata, pointInterval: 60 * 1000 }, { name: 'Size (MB)', data: bytedata, pointInterval: 60 * 1000, tooltip: { formatter: function () { return '<b>' + this.series.name + '</b><br/>' + Highcharts.dateFormat('%Y-%m-%d %H:%M:%S', this.x) + '<br/>' + Highcharts.numberFormat(this.y, 2); } }}],
                title: { text: '' },
                credits: { enabled: false }
            });
        }
        catch (err) 
        {
            alert('work:' + err); 
        }

   }
   function onChartWorkloadRedraw() 
   {
       if (!chartWorkload || !chartWorkload.renderTo)
           return;
        var panel = Ext.get(chartWorkload.renderTo);
        if (panel) 
        {
            var size = panel.getSize();
            chartWorkload.setSize(size.width, size.height);
        }
    }
</script>
<div id='chart_workload_container'></div>
<asp:UpdatePanel ID="pnlUpdate" runat="server" UpdateMode="Conditional">
</asp:UpdatePanel>  