﻿<%@ Control Language="C#" AutoEventWireup="true" CodeBehind="DetailMonitors.ascx.cs" Inherits="MQAWeb.Forms.FTE.Agents.Dashboards.DetailMonitors" %>
<%@ Register assembly="Ext.Net" namespace="Ext.Net" tagprefix="ext" %>
<script type="text/javascript">
    var prepareFTEMonCommand = function (grid, command, record, row) {
        // routine to handle action icon displays
        if (command.command == 'Manage') {
            if (record.data.ManageAction == 0) {
                command.qtitle = 'Pause this Monitor';
                command.qtext = 'click here to Request Pausing of this Monitor';
                command.iconCls = 'icon-pausegreen';
            }
            if (record.data.ManageAction == 1) {
                command.qtitle = 'Resume this Monitor';
                command.qtext = 'click here to Request Resuming of this Monitor';
                command.iconCls = 'icon-playgreen';
            }
            /*
            if (record.data.Status == 0) 
            {
            command.hidden = true;
            command.hideMode = 'display';
            }
            */
        }
        if (command.command == 'Delete') {
            // remove the button if the monitor is already deleted
            if (record.data.Status == 99) {
                command.hidden = true;
                command.hideMode = 'display';
            }
        }
        if (command.command == 'ClearHistory') 
        {
            command.hidden = record.data.Status != 1;
            command.hideMode = 'display';
        }
    }

    function onInvokeView(grid, rowIndex, e) 
    {
        // routine to view the double clicked row
        var store = grid.getStore();
        var record = store.getAt(rowIndex);
        grid.fireEvent('command', 'ViewDetails', record, rowIndex);
    }
    function getFTEMonRowClass(record) 
    {
        // routine to return a row color
        return 'ftemonitor' + record.data.Style;
    }

    var onViewAgent = function (response, result) 
    {
        // routine handle the viewing of agent
        var agentId = result.extraParamsResponse.agentId;
        ShowFTEAgent(agentId);
    };
    var numberFormat = function (value) 
    {
        var renderer = Ext.util.Format.numberRenderer('0,0');
        return renderer(value);
    };
    var onUpdateTotal = function (grid) 
    {
        // routine to work out the final total for the grid
        var fbar = grid.getBottomToolbar();
        var column;
        var field;
        var width;
        var data = {};
        var c;
        var cs = grid.view.getColumnData();
        for (var j = 0, jlen = grid.store.getCount(); j < jlen; j++) 
        {
            // loop through the records in the grid and work out the summary per record per column
            var r = grid.store.getAt(j);

            for (var i = 0, len = cs.length; i < len; i++) 
            {
                c = cs[i];
                column = grid.getColumnModel().columns[i];
                if (column.summaryType) 
                {
                    data[c.name] = Ext.grid.GroupSummary.Calculations[column.summaryType](data[c.name] || 0, r, c.name, data);
                }
            }

        }
        for (var i = 0; i < grid.getColumnModel().columns.length; i++) 
        {
            column = grid.getColumnModel().columns[i];

            if (column.dataIndex == grid.store.groupField)
                continue;

            // get the bottom bar field  
            field = null;
            if (i == 0)
                field = fbar.findBy(function (item) { return item.dataIndex === 'RowNum'; });
            if (i == 1)
                field = fbar.findBy(function (item) { return item.dataIndex === 'Command'; });
            if (field == null)
                field = fbar.findBy(function (item) { return item.dataIndex === column.dataIndex; });
            if (field == null || field.length == 0)
                continue;
            field = field[0];

            // update the value 
            c = cs[i];

            // add the field
            width = grid.getColumnModel().getColumnWidth(i);
            fbar.remove(field, false);
            fbar.insert(i, field);
            field.setWidth(width);
            if (c.name == null || c.name == '')
                continue;
            if (data[c.name] == null)
                continue;
            field.setValue((column.summaryRenderer || c.renderer)(data[c.name], {}, {}, 0, i, grid.store));
       }
        fbar.doLayout();
    };

</script>
 
 <asp:UpdatePanel ID="pnlFTEAgentMonitors" runat="server" UpdateMode="Conditional">
     <ContentTemplate>
                 <ext:GridPanel ID="grdFTEAgentMonitors" runat="server"
                     Border="false" Header="false" Layout="Fit" AutoWidth="True" Height="500" EnableTheming="True">
                     
                     <store>
                         <ext:Store ID="Store1" runat="server">
                             <reader>
                                 <ext:JsonReader IDProperty="Oid">
                                     <Fields>
                                        <ext:RecordField Name="Name" Type="String" SortType="AsUCString"/>                                        <ext:RecordField Name="AgentATQM" Type="String" SortType="AsUCString"/>
                                        <ext:RecordField Name="Style" Type="String" SortType="AsUCString"/>
                                        <ext:RecordField Name="Status" Type="Int" SortType="AsInt"/>
                                        <ext:RecordField Name="ManageAction" Type="Int" SortType="AsInt"/>
                                        <ext:RecordField Name="Oid" Type="Int" SortType="AsInt"/>
                                        <ext:RecordField Name="Status" Type="Int" SortType="AsInt"/>
                                        <ext:RecordField Name="LastUpdateAsString" Type="String" SortType="AsDate"/>
                                        <ext:RecordField Name="PollingInterval" Type="String" SortType="AsUCString"/>
                                        <ext:RecordField Name="Resource" Type="String" SortType="AsUCString"/>
                                        <ext:RecordField Name="Trigger" Type="String" SortType="AsUCString"/>
                                        <ext:RecordField Name="Satisfied" Type="Int" SortType="AsInt"/>
                                        <ext:RecordField Name="UnSatisfied" Type="Int" SortType="AsInt"/>
                                        <ext:RecordField Name="Failed" Type="Int" SortType="AsInt"/>
                                     </Fields>
                                 </ext:JsonReader>
                             </reader>
                         </ext:Store>
                     </store>
                     <columnmodel runat="server">
                         <Columns>
                             <ext:RowNumbererColumn />
                             <ext:ImageCommandColumn Width="100" Header="Operations" >
                            <Commands>
                                <ext:ImageCommand Icon="Magnifier" CommandName="ViewDetails">
                                    <ToolTip Text="click here to View Monitor Details" Title="View Details" />
                                </ext:ImageCommand>                        
                                <ext:ImageCommand Icon="PlayGreen" CommandName="Manage">
                                    <ToolTip Text="click here to Pause/Resume this Monitor" Title="Pause/Resume" />
                                </ext:ImageCommand>                        
                                  <ext:ImageCommand Icon="Delete" CommandName="Delete">
                                    <ToolTip Text="click here to Request Deletion of this Monitor<br>This is a permanent action" Title="Delete"/>
                                </ext:ImageCommand>                        
                                  <ext:ImageCommand Icon="TimeDelete" CommandName="ClearHistory">
                                    <ToolTip Text="click here to Clear Trigger History for this Monitor" Title="Clear History"/>
                                </ext:ImageCommand>                        


                             </Commands>
                            <PrepareCommand Fn="prepareFTEMonCommand"></PrepareCommand>
                            </ext:ImageCommandColumn>
                             <ext:Column ColumnID="colFTEAMonAgentATQM" DataIndex="AgentATQM" Header="Agent-QM" Sortable="true" Width="200" Hidden="True" />
                             <ext:GroupingSummaryColumn ColumnID="colFTEAMonName" DataIndex="Name" Header="Name" Sortable="true" Width="150" SummaryType="Count">
                                 <SummaryRenderer Handler="return ((value === 0 || value > 1) ?  numberFormat(value) +' Monitors' : '1 Monitor');" />    
                             </ext:GroupingSummaryColumn>
                             <ext:Column ColumnID="colFTEMonTrigger" Wrap="True" DataIndex="Trigger" Header="Trigger Information" Width="250" >
                             <Renderer Fn="nl2br"></Renderer>    
                             </ext:Column>
                             <ext:Column ColumnID="colFTEMonResource" Wrap="True" DataIndex="Resource" Header="Resource Information" Width="180" >
                             <Renderer Fn="nl2br"></Renderer>    
                             </ext:Column>
                             <ext:Column ColumnID="colFTEMonPolling" Wrap="True" DataIndex="PollingInterval" Header="Polling Interval" Width="100" ></ext:Column>
                             <ext:Column ColumnID="colFTEMonLUpdate" DataIndex="LastUpdateAsString" Header="Last Update Date" Sortable="True" Width="170" Wrap="True"/>
                              <ext:GroupingSummaryColumn ColumnID="colFTEMonSatisified" DataIndex="Satisfied" Header="ST. Count" Sortable="true" Width="80" Tooltip="Satisfied Trigger Count" Align="Right" SummaryType="Sum">
                                 <Renderer Fn="numberFormat"></Renderer>    
                                 <SummaryRenderer Handler="return numberFormat(value);"/>
                             </ext:GroupingSummaryColumn>
                              <ext:GroupingSummaryColumn ColumnID="colFTEMonNSatisified" DataIndex="NotSatisfied" Header="UST. Count" Sortable="true" Width="80" Tooltip="Un-Satisfied Trigger Count" Align="Right" SummaryType="Sum">
                                 <Renderer Fn="numberFormat"></Renderer>    
                                 <SummaryRenderer Handler="return numberFormat(value);"/>
                             </ext:GroupingSummaryColumn>
                              <ext:GroupingSummaryColumn ColumnID="colFTEMonFailed" DataIndex="Failed" Header="FT. Count" Sortable="true" Width="80" Tooltip="Failed Trigger Count" Align="Right" SummaryType="Sum">
                                 <Renderer Fn="numberFormat"></Renderer>    
                                 <SummaryRenderer Handler="return numberFormat(value);"/>
                             </ext:GroupingSummaryColumn>
                     </Columns>
                     <Listeners>
                        <WidthChange Handler="onUpdateTotal(#{grdFTEAgentMonitors});" />
                      </Listeners>
                     </columnmodel>
                                 <BottomBar>
                <ext:Toolbar ID="bbarBotFTEMon" runat="server">
                    <Items>
                        <ext:DisplayField ID="colFTEMonTotalRowNum" runat="server" DataIndex="RowNum" Cls="extnettotal-field" Text=""/>
                        <ext:DisplayField ID="colFTEMonTotalCommand" runat="server" DataIndex="Command" Cls="extnettotal-field" Text=""/>
                        <ext:DisplayField ID="colFTEMonTotalName" runat="server" DataIndex="Name" Cls="extnettotal-field" StyleSpec="text-align:left;" Text="-"/>
                        <ext:DisplayField ID="colFTEMonTotalTrigger" runat="server" DataIndex="Trigger" Cls="extnettotal-field" StyleSpec="text-align:left;" Text="-"/>
                        <ext:DisplayField ID="colFTEMonTotalResource" runat="server" DataIndex="Resource" Cls="extnettotal-field" StyleSpec="text-align:left;" Text="-"/>
                        <ext:DisplayField ID="colFTEMonTotalPolling" runat="server" DataIndex="Polling" Cls="extnettotal-field" Text=""/>
                        <ext:DisplayField ID="colFTEMonTotalLUpdate" runat="server" DataIndex="LastUpdateAsString" Cls="extnettotal-field" Text=""/>
                        <ext:DisplayField ID="colFTEMonTotalSTCount" runat="server" DataIndex="Satisfied" Cls="extnettotal-field" Text=""/>
                        <ext:DisplayField ID="colFTEMonTotalUSTCount" runat="server" DataIndex="NotSatisfied" Cls="extnettotal-field" Text=""/>
                        <ext:DisplayField ID="colFTEMonTotalFailed" runat="server" DataIndex="Failed" Cls="extnettotal-field" Text="-"/>
                    </Items>
                </ext:Toolbar>
            </BottomBar>
                         <Listeners>
                <ColumnResize Handler="onUpdateTotal(#{grdFTEAgentMonitors});" />
                <AfterRender Handler="onUpdateTotal(#{grdFTEAgentMonitors});"/>
                <Update Handler="onUpdateTotal(#{grdFTEAgentMonitors});"/>
                <RowDblClick Fn="onInvokeView" />
            </Listeners>
             <DirectEvents>
                        <Command OnEvent="Command" Timeout="200000">
                            <Confirmation ConfirmRequest="True" BeforeConfirm="return (command != 'ViewDetails');" Message="Proceed with Operation" Title="FTE Monitor Operation"></Confirmation>
                            <EventMask ShowMask="True"></EventMask>
                            <ExtraParams>
                                <ext:Parameter Name="id" Value="record.data.Oid" Mode="Raw" />
                                <ext:Parameter Name="name" Value="record.data.Name" Mode="Raw" />
                                <ext:Parameter Name="action" Value="record.data.ManageAction" Mode="Raw" />
                                <ext:Parameter Name="status" Value="record.data.Status" Mode="Raw" />
                                <ext:Parameter Name="command" Value="command" Mode="Raw" />
                            </ExtraParams>
                        </Command>
                         <GroupDblClick OnEvent="GroupHeaderClick" Success="onViewAgent">
                             <EventMask ShowMask="True"></EventMask>
                             <ExtraParams>
                                 <ext:Parameter Name="Header" Value="arguments[2]" Mode="Raw"></ext:Parameter>
                             </ExtraParams>
                         </GroupDblClick>

                        </DirectEvents>
                     <Plugins>
                    <ext:GridFilters runat="server" ID="gfFTEAgentMonitors" Local="true">
                        <Filters>
                            <ext:StringFilter DataIndex="Name" />
                            <ext:StringFilter DataIndex="NameATQM" />
                        </Filters>
                    </ext:GridFilters>
                     <ext:GroupingSummary ID="GroupingSummary1" runat="server"/>
                </Plugins>
                <View>
                     <ext:GroupingView ID="gvFTEAgentMonitors" HideGroupedColumn="true" runat="server" ForceFit="true" StartCollapsed="False" EnableRowBody="true" ShowGroupName="False" AutoFill="False" EnableGrouping="False" ScrollOffset="1">
                       <GetRowClass Fn="getFTEMonRowClass"></GetRowClass>
                    </ext:GroupingView>                 
                </View>          
                <ToolTips>
                    <ext:ToolTip ID="AgentTip"  runat="server" Target="={#{grdFTEAgentMonitors}.getView().mainBody}"  
                    Delegate=".x-grid-group-hd" TrackMouse="true">
                    <Listeners>
                        <Show Handler="var agentat = this.triggerElement.id.split('-')[4]; var data = agentat.split('@'); this.body.dom.innerHTML = '<b>Double-Click here to View Details for</b><br/> Agent:' + data[0] + '<br/>Queue Manager:' + data[1];
                        "/>        
                    </Listeners>    
                    </ext:ToolTip>     
                </ToolTips>
                                                                  
                 </ext:GridPanel>
     </ContentTemplate>
</asp:UpdatePanel>
        