﻿<%@ Control Language="C#" AutoEventWireup="true" CodeBehind="DetailSchedules.ascx.cs" Inherits="MQAWeb.Forms.FTE.Agents.Dashboards.DetailSchedules" %>
<%@ Register assembly="Ext.Net" namespace="Ext.Net" tagprefix="ext" %>
<script type="text/javascript">
    var prepareFTESchedCommand = function (grid, command, record, row) {
        // routine to handle action icon displays
        if (command.command == 'Manage') {
            if (record.data.ManageAction == 0) {
                command.qtitle = 'Pause this Schedule';
                command.qtext = 'click here to Request Pausing of this Schedule';
                command.iconCls = 'icon-pausegreen';
            }
            if (record.data.ManageAction == 1) {
                command.qtitle = 'Resume this Schedule';
                command.qtext = 'click here to Request Resuming of this Schedule';
                command.iconCls = 'icon-playgreen';
            }
        }
        if (command.command == 'Delete') {
            // remove the button if the schedule is already deleted
            if (record.data.Status == 99) {
                command.hidden = true;
                command.hideMode = 'display';
            }
        }
    }

    function onInvokeView(grid, rowIndex, e) 
    {
        // routine to view the double clicked row
        var store = grid.getStore();
        var record = store.getAt(rowIndex);
        grid.fireEvent('command', 'ViewDetails', record, rowIndex);
    }
    function getFTESchedRowClass(record) 
    {
        // routine to return a row color
        return 'ftemonitor' + record.data.Style;
    }

    var onViewAgent = function (response, result) 
    {
        // routine handle the viewing of agent
        var agentId = result.extraParamsResponse.agentId;
        ShowFTEAgent(agentId);
    };
    var numberFormat = function (value) 
    {
        var renderer = Ext.util.Format.numberRenderer('0,0');
        return renderer(value);
    };
    var onUpdateTotal = function (grid) 
    {
        // routine to work out the final total for the grid
        var fbar = grid.getBottomToolbar();
        var column;
        var field;
        var width;
        var data = {};
        var c;
        var cs = grid.view.getColumnData();
        for (var j = 0, jlen = grid.store.getCount(); j < jlen; j++) 
        {
            // loop through the records in the grid and work out the summary per record per column
            var r = grid.store.getAt(j);

            for (var i = 0, len = cs.length; i < len; i++) 
            {
                c = cs[i];
                column = grid.getColumnModel().columns[i];
                if (column.summaryType) 
                {
                    data[c.name] = Ext.grid.GroupSummary.Calculations[column.summaryType](data[c.name] || 0, r, c.name, data);
                }
            }

        }
        for (var i = 0; i < grid.getColumnModel().columns.length; i++) 
        {
            column = grid.getColumnModel().columns[i];

            if (column.dataIndex == grid.store.groupField)
                continue;

            // get the bottom bar field  
            field = null;
            if (i == 0)
                field = fbar.findBy(function (item) { return item.dataIndex === 'RowNum'; });
            if (i == 1)
                field = fbar.findBy(function (item) { return item.dataIndex === 'Command'; });
            if (field == null)
                field = fbar.findBy(function (item) { return item.dataIndex === column.dataIndex; });
            if (field == null || field.length == 0)
                continue;
            field = field[0];

            // update the value 
            c = cs[i];

            // add the field
            width = grid.getColumnModel().getColumnWidth(i);
            fbar.remove(field, false);
            fbar.insert(i, field);
            field.setWidth(width);
            if (c.name == null || c.name == '')
                continue;
            if (data[c.name] == null)
                continue;
            field.setValue((column.summaryRenderer || c.renderer)(data[c.name], {}, {}, 0, i, grid.store));
       }
        fbar.doLayout();
    };

</script>
 
 <asp:UpdatePanel ID="pnlFTEAgentSchedule" runat="server" UpdateMode="Conditional">
     <ContentTemplate>
                 <ext:GridPanel ID="grdFTEAgentSchedule" runat="server"
                     Border="false" Header="false" Layout="Fit" AutoWidth="True" Height="500" EnableTheming="True">
                     
                     <store>
                         <ext:Store ID="Store1" runat="server">
                             <reader>
                                 <ext:JsonReader IDProperty="Oid">
                                     <Fields>
                                        <ext:RecordField Name="Name" Type="String" SortType="AsUCString"/>
                                        <ext:RecordField Name="Destination" Type="String" SortType="AsUCString"/>
                                        <ext:RecordField Name="AgentATQM" Type="String" SortType="AsUCString"/>
                                        <ext:RecordField Name="Style" Type="String" SortType="AsUCString"/>
                                        <ext:RecordField Name="Status" Type="Int" SortType="AsInt"/>
                                        <ext:RecordField Name="ManageAction" Type="Int" SortType="AsInt"/>
                                        <ext:RecordField Name="Oid" Type="Int" SortType="AsInt"/>
                                        <ext:RecordField Name="LastUpdate" Type="String" SortType="AsUCString"/>
                                        <ext:RecordField Name="LastSubmit" Type="String" SortType="AsUCString"/>
                                        <ext:RecordField Name="NextSubmit" Type="String" SortType="AsUCString"/>
                                        <ext:RecordField Name="RepeatInterval" Type="String" SortType="AsUCString"/>
                                        <ext:RecordField Name="Expiry" Type="String" SortType="AsUCString"/>
                                        <ext:RecordField Name="TimeZone" Type="String" SortType="AsUCString"/>
                                        <ext:RecordField Name="Satisfied" Type="Int" SortType="AsInt"/>
                                        <ext:RecordField Name="UnSatisfied" Type="Int" SortType="AsInt"/>
                                     </Fields>
                                 </ext:JsonReader>
                             </reader>
                         </ext:Store>
                     </store>
                     <columnmodel runat="server">
                         <Columns>
                             <ext:RowNumbererColumn />
                             <ext:ImageCommandColumn Width="100" Header="Operations" >
                            <Commands>
                                <ext:ImageCommand Icon="Magnifier" CommandName="ViewDetails">
                                    <ToolTip Text="click here to View Schedule Details" Title="View Details" />
                                </ext:ImageCommand>                        
                                <ext:ImageCommand Icon="PlayGreen" CommandName="Manage">
                                    <ToolTip Text="click here to Pause/Resume this Schedule" Title="Pause/Resume" />
                                </ext:ImageCommand>                        
                                  <ext:ImageCommand Icon="Delete" CommandName="Delete">
                                    <ToolTip Text="click here to Request Deletion of this Schedule<br>This is a permanent action" Title="Delete"/>
                                </ext:ImageCommand>                        

                             </Commands>
                            <PrepareCommand Fn="prepareFTESchedCommand"></PrepareCommand>
                            </ext:ImageCommandColumn>
                             <ext:Column ColumnID="colFTEASchedAgentATQM" DataIndex="AgentATQM" Header="Source Agent-QM" Sortable="true" Width="200" Hidden="True" />
                             <ext:GroupingSummaryColumn ColumnID="colFTESchedName" DataIndex="Name" Header="Name" Sortable="true" Width="150" SummaryType="Count">
                                 <SummaryRenderer Handler="return ((value === 0 || value > 1) ?  numberFormat(value) +' Schedules' : '1 Schedule');" />    
                             </ext:GroupingSummaryColumn>
                             <ext:Column ColumnID="colFTESchedDestination" Wrap="True" DataIndex="Destination" Header="Destination" Width="200"/>
                             <ext:Column ColumnID="colFTESchedTimeZone" DataIndex="TimeZone" Header="Time Zone" Sortable="True" Width="170" Wrap="True"/>
                             <ext:Column ColumnID="colFTESchedLSubmit" DataIndex="LastSubmit" Header="Scheduled Start" Sortable="True" Width="170" Wrap="True"/>
                             <ext:Column ColumnID="colFTESchedRepeat" Wrap="True" DataIndex="RepeatInterval" Header="Destination" Width="200"/>
                             <ext:Column ColumnID="colFTESchedExpiry" Wrap="True" DataIndex="Expiry" Header="Repeat Until" Width="200"/>
                             <ext:Column ColumnID="colFTESchedNSubmit" DataIndex="NextSubmit" Header="Next Check" Sortable="True" Width="170" Wrap="True"/>
                             <ext:Column ColumnID="colFTESchedLUpdate" DataIndex="LastUpdate" Header="Last Update" Sortable="True" Width="170" Wrap="True"/>
                             <ext:GroupingSummaryColumn ColumnID="colFTESchedSatisified" DataIndex="Satisfied" Header="Count" Sortable="true" Width="80" Tooltip="Trigger Count" Align="Right" SummaryType="Sum">
                                 <Renderer Fn="numberFormat"></Renderer>    
                                 <SummaryRenderer Handler="return numberFormat(value);"/>
                             </ext:GroupingSummaryColumn>
                              <ext:GroupingSummaryColumn ColumnID="colFTESchedNSatisified" DataIndex="UnSatisfied" Header="S. Count" Sortable="true" Width="80" Tooltip="Skipped Count" Align="Right" SummaryType="Sum">
                                 <Renderer Fn="numberFormat"></Renderer>    
                                 <SummaryRenderer Handler="return numberFormat(value);"/>
                             </ext:GroupingSummaryColumn>
                     </Columns>
                     <Listeners>
                        <WidthChange Handler="onUpdateTotal(#{grdFTEAgentSchedule});" />
                      </Listeners>
                     </columnmodel>
                                 <BottomBar>
                <ext:Toolbar ID="bbarBotFTESched" runat="server">
                    <Items>
                        <ext:DisplayField ID="colFTESchedTotalRowNum" runat="server" DataIndex="RowNum" Cls="extnettotal-field" Text=""/>
                        <ext:DisplayField ID="colFTESchedTotalCommand" runat="server" DataIndex="Command" Cls="extnettotal-field" Text=""/>
                        <ext:DisplayField ID="colFTESchedTotalName" runat="server" DataIndex="Name" Cls="extnettotal-field" StyleSpec="text-align:left;" Text="-"/>
                        <ext:DisplayField ID="colFTESchedTotalDestination" runat="server" DataIndex="Destination" Cls="extnettotal-field" StyleSpec="text-align:left;" Text="-"/>
                        <ext:DisplayField ID="colFTESchedTotalTimeZone" runat="server" DataIndex="TimeZone" Cls="extnettotal-field" StyleSpec="text-align:left;" Text="-"/>
                        <ext:DisplayField ID="colFTESchedTotalSubmit" runat="server" DataIndex="LastSubmit" Cls="extnettotal-field" StyleSpec="text-align:left;" Text="-"/>
                        <ext:DisplayField ID="colFTESchedTotalRepeat" runat="server" DataIndex="RepeatInterval" Cls="extnettotal-field" Text=""/>
                        <ext:DisplayField ID="colFTESchedTotalExpiry" runat="server" DataIndex="Expiry" Cls="extnettotal-field" Text=""/>
                        <ext:DisplayField ID="colFTESchedTotalNSubmit" runat="server" DataIndex="NextSubmit" Cls="extnettotal-field" Text=""/>
                        <ext:DisplayField ID="colFTESchedTotalLUpdate" runat="server" DataIndex="LastUpdate" Cls="extnettotal-field" Text=""/>
                        <ext:DisplayField ID="colFTESchedTotalSTCount" runat="server" DataIndex="Satisfied" Cls="extnettotal-field" Text=""/>
                        <ext:DisplayField ID="colFTESchedTotalUSTCount" runat="server" DataIndex="UnSatisfied" Cls="extnettotal-field" Text=""/>
                    </Items>
                </ext:Toolbar>
            </BottomBar>
                         <Listeners>
                <ColumnResize Handler="onUpdateTotal(#{grdFTEAgentSchedule});" />
                <AfterRender Handler="onUpdateTotal(#{grdFTEAgentSchedule});"/>
                <Update Handler="onUpdateTotal(#{grdFTEAgentSchedule});"/>
                <RowDblClick Fn="onInvokeView" />
            </Listeners>
             <DirectEvents>
                        <Command OnEvent="Command" Timeout="200000">
                            <Confirmation ConfirmRequest="True" BeforeConfirm="return (command != 'ViewDetails');" Message="Proceed with Operation" Title="FTE Schedule Operation"></Confirmation>
                            <EventMask ShowMask="True"></EventMask>
                            <ExtraParams>
                                <ext:Parameter Name="id" Value="record.data.Oid" Mode="Raw" />
                                <ext:Parameter Name="name" Value="record.data.Name" Mode="Raw" />
                                <ext:Parameter Name="action" Value="record.data.ManageAction" Mode="Raw" />
                                <ext:Parameter Name="status" Value="record.data.Status" Mode="Raw" />
                                <ext:Parameter Name="command" Value="command" Mode="Raw" />
                            </ExtraParams>
                        </Command>
                         <GroupDblClick OnEvent="GroupHeaderClick" Success="onViewAgent">
                             <EventMask ShowMask="True"></EventMask>
                             <ExtraParams>
                                 <ext:Parameter Name="Header" Value="arguments[2]" Mode="Raw"></ext:Parameter>
                             </ExtraParams>
                         </GroupDblClick>

                        </DirectEvents>
                     <Plugins>
                    <ext:GridFilters runat="server" ID="gfFTEAgentSchedule" Local="true">
                        <Filters>
                            <ext:StringFilter DataIndex="Name" />
                            <ext:StringFilter DataIndex="NameATQM" />
                        </Filters>
                    </ext:GridFilters>
                     <ext:GroupingSummary ID="GroupingSummary1" runat="server"/>
                </Plugins>
                <View>
                     <ext:GroupingView ID="gvFTEAgentSchedule" HideGroupedColumn="true" runat="server" ForceFit="true" StartCollapsed="False" EnableRowBody="true" ShowGroupName="False" AutoFill="False" EnableGrouping="False" ScrollOffset="1">
                       <GetRowClass Fn="getFTESchedRowClass"></GetRowClass>
                    </ext:GroupingView>                 
                </View>          
                <ToolTips>
                    <ext:ToolTip ID="AgentTip"  runat="server" Target="={#{grdFTEAgentSchedule}.getView().mainBody}"  
                    Delegate=".x-grid-group-hd" TrackMouse="true">
                    <Listeners>
                        <Show Handler="var agentat = this.triggerElement.id.split('-')[4]; var data = agentat.split('@'); this.body.dom.innerHTML = '<b>Double-Click here to View Details for</b><br/> Agent:' + data[0] + '<br/>Queue Manager:' + data[1];
                        "/>        
                    </Listeners>    
                    </ext:ToolTip>     
                </ToolTips>
                                                                  
                 </ext:GridPanel>
     </ContentTemplate>
</asp:UpdatePanel>
        