﻿<%@ Control Language="C#" AutoEventWireup="true" CodeBehind="MonitorDayWorkload.ascx.cs" Inherits="MQAWeb.Forms.FTE.Agents.Dashboards.MonitorDayWorkload" %>
<%@ Register assembly="Ext.Net" namespace="Ext.Net" tagprefix="ext" %>
<script type="text/javascript">
    var chartMonitorWorkload;
    function onMonitorWorkloadChartInvokeRefresh(widgetId) 
    {
        var widget = Ext.getCmp(widgetId);
        doServerCommand(widgetId + 'Controller', widgetId + 'Command', new CommandData('refresh', null), widget.el.dom, null);
    }

    function onMonitorWorkloadAddPoints(year, month, day, hour, min, sec, satisfied, failed, notsatisfied) 
    {
        // routine to add points to the chart
        try {
            var date = Date.UTC(year, month, day, hour, min);

            // check if the chart has a series
            if (!chartMonitorWorkload.series[0].points.length) 
            {
                // get the data
                var series1data = [];
                series1data.push([date, satisfied]);
                var series2data = [];
                series2data.push([date, failed]);
                var series3data = []
                series3data.push([date, notsatisfied]);
                chartMonitorWorkload.series[0].setData(series1data);
                chartMonitorWorkload.series[1].setData(series2data);
                chartMonitorWorkload.series[2].setData(series3data);
            }
            else {
                var shift = chartMonitorWorkload.series[0].data.length > 10;
                chartMonitorWorkload.series[0].addPoint([date, satisfied], false, shift);
                chartMonitorWorkload.series[1].addPoint([date, failed], false, shift);
                chartMonitorWorkload.series[2].addPoint([date, notsatisfied], false, shift);
            }
            onChartMonitorWorkloadRedraw();
        }
        catch (err) {
            alert('monitor-work-point:' + err);
        }
    }

    function onMonitorWorkloadChartInitialize(widgetId, year, month, day, hour, min, sec, satisfied, failed, notsatisfied) 
    {
        try 
        {
            // get the data
            var date = Date.UTC(year, month, day, hour, min);
            var series1data = [];
            series1data.push([date, satisfied]);
            var series2data = [];
            series2data.push([date, failed]);
            var series3data = []
            series3data.push([date, notsatisfied]);

            chartMonitorWorkload = new Highcharts.Chart({
                chart: { renderTo: 'chart_monitor_workload_container', type: 'spline', marginRight: 10,
                    animation: { duration: 940, easing: 'linear' },
                    events:
            {
                load: function () {
                    setInterval(function () {
                        onMonitorWorkloadChartInvokeRefresh(widgetId);
                    }, 60000);
                }
            }
                },
                xAxis:
            {
                type: 'datetime',
                tickInterval: 60 * 1000
            },
                yAxis:
            {
                title:
                {
                    text: 'Value'
                }
            },
                tooltip:
            {
                formatter: function () {
                    value = Highcharts.numberFormat(this.y, 0);
                    return '<b>' + this.series.name + '</b><br/>' + Highcharts.dateFormat('%Y-%m-%d %H:%M:%S', this.x) + '<br/>' + value;
                }
            },
                legend:
           {
               enabled: true
           },
                series: [{ name: 'Satisfied', data: series1data, pointInterval: 60 * 1000 }, { name: 'Failed', data: series2data, pointInterval: 60 * 1000 }, { name: 'Un-Satisfied', data: series3data, pointInterval: 60 * 1000, tooltip: { formatter: function () { return '<b>' + this.series.name + '</b><br/>' + Highcharts.dateFormat('%Y-%m-%d %H:%M:%S', this.x) + '<br/>' + Highcharts.numberFormat(this.y, 2); } }}],
                title: { text: '' },
                credits: { enabled: false }
            });
        }
        catch (err) 
        {
            alert('monitor-work:' + err); 
        }

   }
   function onChartMonitorWorkloadRedraw() 
   {
       // routine to refresh this screen
       if (!chartMonitorWorkload || !chartMonitorWorkload.renderTo)
           return;
        var panel = Ext.get(chartMonitorWorkload.renderTo);
        if (panel) 
        {
            var size = panel.getSize();
            if (size.width > 0)
                chartMonitorWorkload.setSize(size.width, size.height);
        }
    }
</script>
<div id='chart_monitor_workload_container'></div>
<asp:UpdatePanel ID="pnlUpdate" runat="server" UpdateMode="Conditional">
</asp:UpdatePanel>  