﻿<%@ Control Language="C#" AutoEventWireup="true" CodeBehind="ByteProgress.ascx.cs" Inherits="MQAWeb.Forms.FTE.Reporting.Widgets.ByteProgress" %>
<%@ Register assembly="Ext.Net" namespace="Ext.Net" tagprefix="ext" %>
<script type="text/javascript">
    var totalTime = 0;
    var totalBytes = 0;
    var totalFiles = 0;
    var totalCurrFiles = 0;
    var numberFormat = function (value) 
    {
        var renderer = Ext.util.Format.numberRenderer('0,0');
        return renderer(value);
    };
    var numberFormatDec = function (value) 
    {
        var renderer = Ext.util.Format.numberRenderer('0,0.00');
        return renderer(value);
    };
    var numberFormatBytes = function (value) 
    {
        // routine to format the bytes
        if (isNaN(value))
            return '-';
        var i = bytesToSize(value);
        var str = numberFormat(value / Math.pow(1024, i));
        return str + ' ' + filesizes[i];
    };
    
    var onSumFiles = function (v, record, field) 
    {
        // routine to calculate the total kb per sec total
        if (v == 0) 
        {
            v = 1;
            totalFiles = 0;
            totalCurrFiles = 0;
        }
        totalCurrFiles += record.get('CurrentFile');
        totalFiles += record.get('TotalFiles');
        return v;
    };

    var totalRate = function (v, record, field) 
    {
        // routine to calculate the total kb per sec total
        if (v == 0) 
        {
            v = 1;
            totalTime = 0;
            totalBytes = 0;
        }
        totalBytes += record.get('ElapsedBytes');
        totalTime += record.get('ElapsedTime');
        return v;
    };
    
    var onViewSourceAgent = function(response, result)
    {
        // routine handle the viewing of source agent 
        var agentId = result.extraParamsResponse.agentId;
        ShowFTEAgent(agentId);
    };

    var onUpdateTotal = function(grid) 
    {
        // routine to work out the final total for the grid
        var fbar = grid.getBottomToolbar();
        var column;
        var field;
        var width;
        var data = { };
        var c;
        var cs = grid.view.getColumnData();
        for (var j = 0, jlen = grid.store.getCount(); j < jlen; j++) 
        {
            // loop through the records in the grid and work out the summary per record per column
            var r = grid.store.getAt(j);

            for (var i = 0, len = cs.length; i < len; i++) 
            {
                c = cs[i];
                column = grid.getColumnModel().columns[i];
                if (column.id == 'colFTEByteFiles')
                {
                    data['totalFiles'] = Ext.grid.GroupSummary.Calculations['sum'](data['totalFiles'] || 0, r, 'TotalFiles', data);
                    data['totalCurrFiles'] = Ext.grid.GroupSummary.Calculations['sum'](data['totalCurrFiles'] || 0, r, 'CurrentFile', data);
                    continue;
                }

                if (column.summaryType) 
                {
                      if (column.id == 'colFTEByteRate') 
                        continue;
                    data[c.name] = Ext.grid.GroupSummary.Calculations[column.summaryType](data[c.name] || 0, r, c.name, data);
                }
            }
            
        }
       // add the rate 
       data['Rate'] = data['ElapsedBytes'] / data['ElapsedTime'];
       for (var i = 0; i < grid.getColumnModel().columns.length; i++) 
       {
            column = grid.getColumnModel().columns[i];

            if (column.dataIndex == grid.store.groupField) 
                continue;
          
            // get the bottom bar field  
            field = null;
            if (i == 0)
                field = fbar.findBy(function(item) {return item.dataIndex === 'RowNum';});
            if (i == 1)
                field = fbar.findBy(function(item) {return item.dataIndex === 'Command';});
            if (field == null)
                field = fbar.findBy(function(item) {return item.dataIndex === column.dataIndex;});
            if (field == null || field.length == 0) 
                continue;
             field = field[0];
            
            // update the value 
            c = cs[i];
            
            // add the field
            width = grid.getColumnModel().getColumnWidth(i);
            fbar.remove(field, false);
            fbar.insert(i, field);
            field.setWidth(width);  
            if (c.name == null || c.name == '')
                continue;
           if (column.id == 'colFTEByteFiles') 
           {
               field.setValue(numberFormat(data['totalCurrFiles']) + '/' + numberFormat(data['totalFiles']));
               continue;
           }
            if (data[c.name] == null)
                continue;
            if (column.id == 'colFTEByteRate') 
            {
                field.setValue(numberFormatBytes(data[c.name]));
            
            } else
                field.setValue((column.summaryRenderer || c.renderer)(data[c.name], { }, { }, 0, i, grid.store));
        }

        fbar.doLayout();
    };
    
    function onGetRowClass(record, rowIndex, p, store) 
    {
        // routine to return a row color
        if (record.data.Style != null && record.data.Style != '')
            return record.data.Style;
    }

    var onFTEByteProgressOper = function (response, result) 
    {
        // routine to handle when we need to view the transaction
        var action = result.extraParamsResponse.action;
        var key = result.extraParamsResponse.data;
        if (action == 'View') 
        {
            ShowFTETransView(key);
        }
        if (action == 'Remove') 
        {
            Ext.Msg.notify('Transactions in Progress', 'A Delete Request has been completed');
        }
    };

    var onFTEByteClearCommand = function(heading) 
    {
        Ext.Msg.confirm('Transactions in In-Progress', 'Are you sure you wish to clear All ' + heading + 'Entries ?', 
            function(btn) 
            {
                if (btn == 'yes') 
                {
                    Ext.net.DirectMethods.<%=ClientID%>.FTEByteProgressClear(heading);
                    return true;
                }
            });
    };
    

    
    var onFTEByteClearSuccess = function(result) 
    {
        Ext.Msg.notify('Transactions In-Progress', 'All ' + result + 'In-Progress Entries has been cleared');
    };

</script>
 
 <asp:UpdatePanel ID="pnlFTEByteProgress" runat="server" UpdateMode="Conditional">
     <ContentTemplate>
                 <ext:GridPanel ID="grdFTEByteProgress" runat="server"
                     Border="false" Header="false" Layout="Fit" AutoWidth="True" Height="500" EnableTheming="True" AutoScroll="True">
                     <SelectionModel>
                        <ext:RowSelectionModel ID="RowSelectionModel1" runat="server" Mode="Single" />
                      </SelectionModel>       
                     <store>
                         <ext:Store ID="grdFTEByteProgressStore" runat="server" GroupField="AgentPair">
                             <reader>
                                 <ext:JsonReader IDProperty="TransactionId">
                                     <Fields>
                                       <ext:RecordField Name="AgentPair" Type="String" SortType="AsUCString"/>
                                       <ext:RecordField Name="TransactionId" Type="String" SortType="AsUCString"/>
                                       <ext:RecordField Name="Type" Type="String" SortType="AsUCString"/>
                                        <ext:RecordField Name="Source" Type="String" SortType="AsUCString"/>
                                        <ext:RecordField Name="Destination" Type="String" SortType="AsUCString"/>
                                        <ext:RecordField Name="SourceInfo" Type="String" SortType="AsUCString"/>
                                        <ext:RecordField Name="DestinationInfo" Type="String" SortType="AsUCString"/>
                                        <ext:RecordField Name="LastUpdateTime" Type="Auto" SortType="AsDate"/>
                                        <ext:RecordField Name="Perc" Type="Float" SortType="AsFloat"></ext:RecordField>
                                        <ext:RecordField Name="Rate" Type="Float" SortType="AsFloat"></ext:RecordField>
                                        <ext:RecordField Name="Style" Type="String"></ext:RecordField>
                                        <ext:RecordField Name="ElapsedBytes" Type="Float" SortType="AsFloat"/>
                                        <ext:RecordField Name="ElapsedTime" Type="Auto"/>
                                        <ext:RecordField Name="CurrentFile" Type="Int" SortType="AsInt"/>
                                        <ext:RecordField Name="TotalFiles" Type="Int" SortType="AsInt"/>
                                     </Fields>
                                 </ext:JsonReader>
                             </reader>
                         </ext:Store>
                     </store>
                     <columnmodel runat="server">
                         <Columns>
                             <ext:RowNumbererColumn />
                             <ext:ImageCommandColumn Width="50" Header="Action" Wrap="False" Fixed="True">
                                <Commands>
                                    <ext:ImageCommand Icon="Magnifier" CommandName="View">
                                        <ToolTip Text="View Transaction Information" Title="View Transaction..." />
                                    </ext:ImageCommand>
                                    <ext:ImageCommand Icon="LinkBreak" CommandName="Remove">
                                        <ToolTip Text="Remove Entry" Title="Remove Entry from the List"/>
                                    </ext:ImageCommand>
                        </Commands>
                            </ext:ImageCommandColumn>

                             <ext:GroupingSummaryColumn ColumnID="colFTEByteTransactionId" DataIndex="TransactionId" Header="TransactionId" Sortable="true" Width="150" SummaryType="Count">
                                 <SummaryRenderer Handler="return ((value === 0 || value > 1) ?  numberFormat(value) +' Transactions' : '1 Transaction');" />    
                               </ext:GroupingSummaryColumn>
                            <ext:Column ColumnID="colFTEByteType" DataIndex="Type" Header="Type" Sortable="true" Width="200" />
                             <ext:Column ColumnID="colFTEByteAgentPair" DataIndex="AgentPair" Header="AgentPair" Sortable="true" Width="300" />
                             <ext:Column ColumnID="colFTEByteSourceInfo" DataIndex="SourceInfo" Header="Transfer Source" Sortable="true" Width="300" />
                             <ext:Column ColumnID="colFTEByteDestInfo" DataIndex="DestinationInfo" Header="Transfer Destination" Sortable="true" Width="300" />
                              <ext:GroupingSummaryColumn ColumnID="colFTEByteFiles" DataIndex="CurrentFile"  Header="Files" Sortable="false" Width="150" CustomSummaryType="onSumFiles" Align="Center">
                                <Renderer Handler="return numberFormat(value) + '/' + numberFormat(record.data.TotalFiles);"></Renderer>    
                                <SummaryRenderer Handler="return numberFormat(totalCurrFiles) + '/' + numberFormat(totalFiles);"/>
                              </ext:GroupingSummaryColumn>
                             <ext:Column ColumnID="colFTEBytePerc" DataIndex="Perc" Header="%" Sortable="true" Width="40" Align="Center" />
                                <ext:GroupingSummaryColumn ColumnID="colFTEByteBytes" DataIndex="ElapsedBytes" Header="Bytes Transferred" Sortable="true" Width="200" Align="Right" SummaryType="Sum">
                                <Renderer Fn="numberFormatBytes"></Renderer>    
                                <SummaryRenderer Fn="numberFormatBytes"/>    
                             </ext:GroupingSummaryColumn>
                             <ext:GroupingSummaryColumn ColumnID="colFTEByteTime" DataIndex="ElapsedTime" Header="Runnning Time" Sortable="true" Width="200" Align="Right" SummaryType="Sum">
                                 <Renderer Fn="numberFormatDec"></Renderer>    
                                 <SummaryRenderer Handler="return numberFormatDec(value) + ' seconds';"/>
                             </ext:GroupingSummaryColumn>
                              <ext:GroupingSummaryColumn ColumnID="colFTEByteRate" DataIndex="Rate" Header="Rate/s" Sortable="true" Width="150" Align="Right" CustomSummaryType="totalRate">
                                 <Renderer Fn="numberFormatBytes"></Renderer>    
                                 <SummaryRenderer Handler="var rate = totalBytes/totalTime; return numberFormatBytes(rate);"/>
                             </ext:GroupingSummaryColumn>

                         </Columns>
                         <Listeners>
                            <WidthChange Handler="onUpdateTotal(#{grdFTEByteProgress});" />
                         </Listeners>
                     </columnmodel>
                       <TopBar>
                        <ext:Toolbar ID="bbarTopFTEByteProgress" runat="server">
                        <Items>
                            <ext:ToolbarFill ID="ToolbarFill1" runat="server" />
                            <ext:Button ID="btnFTEByteCancelErrors" runat="server" Text="Clear all Errors..." ToolTip="click here to Clear All Error Entries in the Display..." Icon="Cancel">
                                 <Listeners>
                                <Click Handler="onFTEByteClearCommand('Error ');"/>
                                </Listeners>
                            </ext:Button>

                            <ext:Button ID="btnFTEByteCancelAll" runat="server" Text="Clear all Transactions..." ToolTip="click here to Clear All Entries in the Display..." Icon="LinkBreak">
                                 <Listeners>
                                 <Click Handler="onFTEByteClearCommand('');"/>
                                </Listeners>
                            </ext:Button>
                        </Items>
                </ext:Toolbar>
            </TopBar>
            <BottomBar>
                <ext:Toolbar ID="bbarBotFTEByteProgress" runat="server">
                    <Items>
                        <ext:DisplayField ID="colFTEByteTotalRowNum" runat="server" DataIndex="RowNum" Cls="extnettotal-field" Text=""/>
                        <ext:DisplayField ID="colFTEByteTotalCommand" runat="server" DataIndex="Command" Cls="extnettotal-field" Text=""/>
                        <ext:DisplayField ID="colFTEByteTotalTransactionId" runat="server" DataIndex="TransactionId" Cls="extnettotal-field" StyleSpec="text-align:left;" Text="-"/>
                        <ext:DisplayField ID="colFTEByteTotalType" runat="server" DataIndex="Type" Cls="extnettotal-field" Text=""/>
                        <ext:DisplayField ID="colFTEByteTotalSourceInfo" runat="server" DataIndex="SourceInfo" Cls="extnettotal-field" Text=""/>
                        <ext:DisplayField ID="colFTEByteTotalDestInfo" runat="server" DataIndex="DestinationInfo" Cls="extnettotal-field" Text=""/>
                        <ext:DisplayField ID="colFTEByteTotalCountInfo" runat="server" DataIndex="CurrentFile" Cls="extnettotal-field" Text="" StyleSpec="text-align:center;"/>
                        <ext:DisplayField ID="colFTEByteTotalPerc" runat="server" DataIndex="Perc" Cls="extnettotal-field" Text=""/>
                        <ext:DisplayField ID="colFTEByteTotalBytes" runat="server" DataIndex="ElapsedBytes" Cls="extnettotal-field" Text="-"/>
                        <ext:DisplayField ID="colFTEByteTotalTime" runat="server" DataIndex="ElapsedTime" Cls="extnettotal-field" Text="-" />
                        <ext:DisplayField ID="colFTEByteTotalRate" runat="server" DataIndex="Rate" Cls="extnettotal-field" Text="-"/>
                    </Items>
                </ext:Toolbar>
            </BottomBar>
             <Listeners>
                <ColumnResize Handler="onUpdateTotal(#{grdFTEByteProgress});" />
                <AfterRender Handler="onUpdateTotal(#{grdFTEByteProgress});" Delay="100" />
                
            </Listeners>

                        <DirectEvents>
                        <Command OnEvent="Command" Success="onFTEByteProgressOper(response, result);">
                            <EventMask ShowMask="True"></EventMask>
                            <Confirmation ConfirmRequest="True" BeforeConfirm="return (command == 'Remove');" Message="Are you sure you which to Clear this Entry..." Title="Confirm"></Confirmation>
                            <ExtraParams>
                                <ext:Parameter Name="id" Value="record.data.TransactionId" Mode="Raw" />
                                <ext:Parameter Name="command" Value="command" Mode="Raw" />
                            </ExtraParams>
                            </Command>
                         <GroupDblClick OnEvent="GroupHeaderClick" Success="onViewSourceAgent">
                             <EventMask ShowMask="True"></EventMask>
                             <ExtraParams>
                                 <ext:Parameter Name="Header" Value="arguments[2]" Mode="Raw"></ext:Parameter>
                             </ExtraParams>
                         </GroupDblClick>
                     </DirectEvents>

                     <Plugins>
                    <ext:GridFilters runat="server" ID="gfFTEByteProgress" Local="true">
                        <Filters>
                            <ext:StringFilter DataIndex="TransactionId" />
                            <ext:StringFilter DataIndex="AgentPair"/>
                            <ext:StringFilter DataIndex="SourceInfo" />
                            <ext:StringFilter DataIndex="DestinationInfo" />
                            <ext:StringFilter DataIndex="Type" />
                        </Filters>
                    </ext:GridFilters>
                    <ext:GroupingSummary ID="GroupingSummary1" runat="server">
                        <Calculations>
                            <ext:JFunction Fn="totalRate" Name="totalRate"/>
                            <ext:JFunction Fn="onSumFiles" Name="onSumFiles"/>
                        </Calculations>
                </ext:GroupingSummary>

                </Plugins>
                 <View>
                <ext:GroupingView  
                    ID="gvFTEByteProgress"
                    HideGroupedColumn="true"
                    runat="server" 
                    ForceFit="true"
                    StartCollapsed="False"
                    EnableRowBody="true" ShowGroupName="False" AutoFill="False" EnableGrouping="True">
                    <GetRowClass Fn="onGetRowClass"></GetRowClass>
                </ext:GroupingView>
                </View>
                <ToolTips>
                    <ext:ToolTip ID="SourceAgentTip"  runat="server" Target="={#{grdFTEByteProgress}.getView().mainBody}"  
                    Delegate=".x-grid-group-hd" TrackMouse="true">
                    <Listeners>
                        <Show Handler="var agentat = this.triggerElement.id.split('-')[4]; var data = agentat.split('@'); this.body.dom.innerHTML = '<b>Double-Click here to View Details for</b><br/> Agent:' + data[0] + '<br/>Queue Manager:' + data[1];
                        "/>        
                    </Listeners>    
                    </ext:ToolTip>     
                </ToolTips>


                 </ext:GridPanel>
     </ContentTemplate>
</asp:UpdatePanel>
        