﻿<%@ Control Language="C#" AutoEventWireup="true" CodeBehind="MQALauncher.ascx.cs" Inherits="MQAWeb.Forms.General.Dashboards.MQALauncher" %>
<%@ Register assembly="Ext.Net" namespace="Ext.Net" tagprefix="ext" %>
 <style type="text/css">        
     
</style>
<script type="text/javascript">
    var prepareCommand = function (grid, command, record, row) {
        // routine to handle action icon displays
        if (command.command == 'Start' && !record.data.AllowStart) {
            // only when it's stopped or unknown
            command.hidden = true;
            command.hideMode = 'display';
        }

        if (command.command == 'ViewError' && !record.data.ShowError) {
            // only when the last error is not empty    
            command.hidden = true;
            command.hideMode = 'display';
        }

        if (command.command == 'Stop' && !record.data.AllowStop) {
            // hide except when its stopped
            command.hidden = true;
            command.hideMode = 'display';
        }
        if (command.command == 'Delete' && !record.data.AllowDelete) {
            // don't allow on everything but unknown and stopped 
            command.hidden = true;
            command.hideMode = 'display';
        }
    };

    function getRowClass(record) 
    {
        // routine to return a row color
        return 'launcher' + record.data.Style;
    }

</script>
 
 <asp:UpdatePanel ID="pnlMQALauncher" runat="server" UpdateMode="Conditional">
     <ContentTemplate>
                 <ext:GridPanel ID="grdLauncher" runat="server"
                     Border="false" Header="false" Layout="Fit" AutoWidth="True" Height="500" EnableTheming="True">
                     <store>
                         <ext:Store ID="Store1" runat="server">
                             <reader>
                                 <ext:JsonReader IDProperty="Oid">
                                     <Fields>
                                         <ext:RecordField Name="StartPid" Type="Int" SortType="AsInt"/>
                                         <ext:RecordField Name="StopPid" Type="Int" SortType="AsInt"/>
                                         <ext:RecordField Name="AllowStart" Type="Boolean"/>
                                         <ext:RecordField Name="AllowStop" Type="Boolean"/>
                                         <ext:RecordField Name="AllowDelete" Type="Boolean"/>
                                         <ext:RecordField Name="ShowError" Type="Boolean"/>
                                         <ext:RecordField Name="Description" Type="String" SortType="AsUCString"/>
                                         <ext:RecordField Name="StartCommand" Type="String" SortType="AsUCString"/>
                                         <ext:RecordField Name="Type" SortType="AsUCString"/>
                                         <ext:RecordField Name="Style" SortType="AsUCString"/>
                                         <ext:RecordField Name="Status" Type="String" SortType="AsUCString"/>
                                         <ext:RecordField Name="Oid" Type="Int" SortType="AsInt"/>
                                     </Fields>
                                 </ext:JsonReader>
                             </reader>
                         </ext:Store>
                     </store>
                     <columnmodel runat="server">
                         <Columns>
                             <ext:Column ColumnID="colMQALPid" DataIndex="StartPid" Header="Pid" Sortable="true" Width="80" Align="Right" />
                             <ext:ImageCommandColumn runat="server" Width="100">
                            <Commands>
                                <ext:ImageCommand Icon="Error" CommandName="ViewError">
                                    <ToolTip Text="View Errors" />
                            </ext:ImageCommand>
                            <ext:ImageCommand Icon="PlayGreen" CommandName="Start">
                                <ToolTip Text="Start this Service" />
                            </ext:ImageCommand>
                             <ext:ImageCommand Icon="StopBlue" CommandName="Stop">
                                <ToolTip Text="Stop this Service" />
                            </ext:ImageCommand>
                             <ext:ImageCommand Icon="Delete" CommandName="Delete">
                                <ToolTip Text="Delete this Service" />
                            </ext:ImageCommand>
                        </Commands>
                        <PrepareCommand Fn="prepareCommand"></PrepareCommand>
                    </ext:ImageCommandColumn>
                             <ext:Column ColumnID="colMQALDesc" DataIndex="Description" Header="Description" Sortable="False" Wrap="True" Width="150"/>
                             <ext:Column ColumnID="colMQALCommand" DataIndex="StartCommand" Header="Start Command" Sortable="False" Wrap="True" Width="250"/>
                             <ext:Column ColumnID="colMQALType" DataIndex="Type" Header="Type" Sortable="True" Wrap="False" Width="100"/>
                             <ext:Column ColumnID="colMQALStatus" DataIndex="Status" Header="Status" Sortable="True" Wrap="False" Width="200"/>
                     </Columns>
                     </columnmodel>
                         <DirectEvents>
                        <Command OnEvent="Command">
                            <Confirmation ConfirmRequest="True" BeforeConfirm="return (command != 'ViewError');" Message="Proceed with Operation" Title="MQALauncher Operation"></Confirmation>
                            <ExtraParams>
                                <ext:Parameter Name="id" Value="record.data.Oid" Mode="Raw" />
                                <ext:Parameter Name="command" Value="command" Mode="Raw" />
                            </ExtraParams>
                        </Command>
                        </DirectEvents>
                     <Plugins>
                    <ext:GridFilters runat="server" ID="GridFilters1" Local="true">
                        <Filters>
                            <ext:NumericFilter DataIndex="Pid" />
                            <ext:StringFilter DataIndex="Description" />
                            <ext:StringFilter DataIndex="Type" />
                        </Filters>
                    </ext:GridFilters>
                </Plugins>
                <View>
                    <ext:GridView ID="gvGPClientDefaultSkills" runat="server" ForceFit="true" ScrollOffset="1">
                        <GetRowClass Fn="getRowClass"></GetRowClass>
                    </ext:GridView>                   
                </View>                                                                            
                 </ext:GridPanel>
     </ContentTemplate>
</asp:UpdatePanel>
        