﻿<%@ Control Language="C#" AutoEventWireup="true" CodeBehind="ReportView.ascx.cs" Inherits="MQAWeb.Forms.General.Widgets.ReportView" %>
<%@ Register assembly="DevExpress.Web.v11.1, Version=11.1.7.0, Culture=neutral, PublicKeyToken=b88d1754d700e49a" namespace="DevExpress.Web.ASPxCallback" tagprefix="dx" %>
<%@ Register assembly="DevExpress.Web.ASPxEditors.v11.1, Version=11.1.7.0, Culture=neutral, PublicKeyToken=b88d1754d700e49a" namespace="DevExpress.Web.ASPxEditors" tagprefix="dx" %>
<%@ Register assembly="DevExpress.Web.v11.1, Version=11.1.7.0, Culture=neutral, PublicKeyToken=b88d1754d700e49a" namespace="DevExpress.Web.ASPxLoadingPanel" tagprefix="dx" %>
<%@ Register TagPrefix="dx" Namespace="DevExpress.Web.ASPxMenu" Assembly="DevExpress.Web.v11.1, Version=11.1.7.0, Culture=neutral, PublicKeyToken=b88d1754d700e49a" %>
<script language="javascript">
    function OnCustomRepSaveAs() 
    {
        // routine to save the report information as a template
        var url = '<%=ResolveUrl("~/Forms/frmDialog.aspx")%>?UserControl=~/Forms/Admin/User/UserTemplateSave.ascx';
        var title = 'Custom Report Save Parameters';
        url += '&Title=' + title;
        url += '&SubTitle=Please provide the Custom Report Information&noCode=1';
        showPopupWindow(popupWin, null, url, title, 500, 225, 100, 50);
    }
    function OnCustomRepDeleteQ() 
    {
        // routine to delete the selected custom report definition
        var agree = confirm('Are you sure you wish to Delete this Custom Report Definition ?');
        if (agree) 
            PerformCallback('CustomRepDelete');
    }

    function OnCustomRepMenuItem(e) 
    {
        // routine to handle menu item invoke on the server side
        var name = e.item.name;
        e.processOnServer = false;
        if (name == 'mnuSaveAs')
            OnCustomRepSaveAs();
        if (name == 'mnuSave')
            PerformCallback('CustomRepSave');
        if (name == 'mnuDelete')
            OnCustomRepDeleteQ();
    }

    function OnCustomRepDelete() 
    {
        // routine to update the Popup Template Options when a Template is Deleted
        OnCustomRepMenuUpdate(1);
        alert('Custom Report Definition Deleted Successfully');
    }
    function OnCustomRepMenuUpdate(type) 
    {
        // routine to update the Custom Report Menu Options
        var item = mnuCustomRep.GetItemByName('mnuDelete');
        if (item != null)
            item.SetVisible((type == 0));
        item = mnuCustomRep.GetItemByName('mnuSave');
        if (item != null)
            item.SetVisible((type == 0));
    }

</script>
<table cellpadding="0" cellspacing="2" border=0 class="topPanel">
     <tr>
    <td>
        <a href="#" target=_self>
            <dx:ASPxButton ID="btnRepRefresh" runat="server" ToolTip="click here to Refresh the Report"  EnableDefaultAppearance="False" ClientInstanceName="btnRepRefresh">
            <Image Url="~/images/General/refresh.png" Width="25" Height="26"></Image>
            <DisabledStyle CssClass="disabled"></DisabledStyle>            
                 <ClientSideEvents Click="function(s, e) 
                 {
	                e.processOnServer = false;
                    OnRefresh();
                  }" />     
            </dx:ASPxButton>
        </a>    
    </td>
    <td>
            <a href="#" target=_self>
            <dx:ASPxButton ID="btnRepFilter" runat="server" 
                ToolTip="click here to Alter Server Filter Options"  
                EnableDefaultAppearance="False" ClientInstanceName="btnRepFilter">
            <Image Url="~/images/General/filter.png" Width="25" Height="26"></Image>
            <DisabledStyle CssClass="disabled"></DisabledStyle>            
                 <ClientSideEvents Click="function(s, e) 
                 {
                    e.processOnServer = false;
                    if (window.OnFilter != undefined)
                    {
                        window.OnFilter();
                    }
                    else
	                    cbPanel.PerformCallback('Filter');
                  }" />     
            </dx:ASPxButton>
        </a>    
    </td>
    <td>
        <a href="#" target=_self>
        <dx:ASPxButton ID="btnRepExport" runat="server"
            ToolTip="click here to Export the Report" onclick="btnRepExport_Click" 
            EnableDefaultAppearance="False" ClientInstanceName="btnRepExport">
            <Image Url="~/images/General/excel.png" Width="25" Height="26"></Image>
            <DisabledStyle CssClass="disabled"></DisabledStyle>            
        </dx:ASPxButton></a>
    </td>
    <td>
    <a href="#" target=_self>
            <dx:ASPxButton ID="btnRepOptions" runat="server" 
            ToolTip="click here to Alter Display Options"  EnableDefaultAppearance="False" 
            ClientInstanceName="btnRepOptions">
            <Image Url="~/images/General/setting.png" Width="25" Height="26"></Image>
            <DisabledStyle CssClass="disabled"></DisabledStyle>            
                 <ClientSideEvents Click="function(s, e) 
                 {
	                e.processOnServer = false;
	                OnReportOptions();
                  }" />     
            </dx:ASPxButton>
        </a>    
    </td>
    <td>
        <a href="#" target=_self>
            <dx:ASPxButton ID="btnRepSave" runat="server" 
            EnableDefaultAppearance="False" ClientInstanceName="btnRepSave" 
            ToolTip="click here to Save Report Definition">
            <Image Url="~/images/General/save.png" Width="25" Height="26"></Image>
            <DisabledStyle CssClass="disabled"></DisabledStyle>
                             <ClientSideEvents Click="function(s, e) 
                {
                	                e.processOnServer = false;

	mnuCustomRep.ShowAtElement(s.GetMainElement());
}" />
</dx:ASPxButton>
        </a>    
    </td>
    <td>
        <a href="#" target=_self>
            <dx:ASPxButton ID="btnRepCSelect" runat="server" 
            EnableDefaultAppearance="False" ClientInstanceName="btnRepCSelect" 
            ClientVisible="False" ToolTip="click here to Customize Available Columns ">
            <Image Url="~/images/General/colselect.png" Width="25" Height="26"></Image>
            <DisabledStyle CssClass="disabled"></DisabledStyle>
            <ClientSideEvents Click="function(s, e) 
                 {
	                e.processOnServer = false;
	                OnRepColumnSelect();
                  }" Init="function(s, e) 
{
	e.processOnServer = false;
	s.SetVisible(window.OnRepColumnSelect != undefined &amp;&amp; window.OnRepColumnSelect != null);
}" />     
            </dx:ASPxButton>
        </a>    
    </td>


  </tr>
  </table>

<dx:ASPxPopupMenu ID="mnuCustomRep" runat="server" 
    ClientInstanceName="mnuCustomRep">
    <Items>
        <dx:MenuItem Name="mnuSaveAs" Text="Save As..." 
            ToolTip="click here to Save the Report as a Custom Report">
            <ItemStyle HorizontalAlign="Left" />
        </dx:MenuItem>
        <dx:MenuItem Name="mnuSave" Text="Save" 
            ToolTip="click here to Save Changes to the Custom Report" ClientVisible="False">
            <ItemStyle HorizontalAlign="Left" />
        </dx:MenuItem>
        <dx:MenuItem Name="mnuDelete" Text="Delete..." 
            ToolTip="click here to Delete the Custom Report" ClientVisible="False">
            <ItemStyle HorizontalAlign="Left" />
        </dx:MenuItem>
    </Items>
     <ClientSideEvents ItemClick="function(s, e) {
	OnCustomRepMenuItem(e);
}" />

</dx:ASPxPopupMenu>